From 6931f26df52149c4a3470d1209d4ca967cc80efc Mon Sep 17 00:00:00 2001
From: Samuel Kunkel <samuel.kunkel@mail.schwarz>
Date: Fri, 17 Feb 2023 14:01:35 +0100
Subject: [PATCH] fix: amd-sev handle missing img properties

during the building / spawning process of a VM with amd-sev nova-compute runs
get_flags_by_flavor_specs which results in a run through scheduler utils
from_request spec where nova does not have any information about the image.
During this execution nova tries to run _translate_memory_encryption
which in itself runs _check_mem_encryption_uses_uefi_image down the
line. But this time nova does not have a single information about the
used image.

At this state there was already a successful run of
_check_mem_encryption_uses_uefi_image. Therefore we can skip whole cycle
if we dont even have image specs present.

Bug: https://bugs.launchpad.net/nova/+bug/2007697
Change-Id: I5b0db2d524b7a97ddf64c669a7ce1e60c80078eb
---


diff --git a/nova/virt/hardware.py b/nova/virt/hardware.py
index 96a7198..6898a1c 100644
--- a/nova/virt/hardware.py
+++ b/nova/virt/hardware.py
@@ -1194,7 +1194,13 @@
         requesters.append("hw_mem_encryption property of image %s" %
                           image_meta.id)

-    _check_mem_encryption_uses_uefi_image(requesters, image_meta)
+    if image_meta.__contains__("id"):
+        # during the iterations triggered within scheduler utils we dont
+        # have any image_meta present. Therefore we would always fail here.
+        # Assuming a valid image_meta atleast needs to contain an id we skip
+        # here if no id is present in the provided image_meta
+        _check_mem_encryption_uses_uefi_image(requesters, image_meta)
+
     _check_mem_encryption_machine_type(image_meta, machine_type)

     LOG.debug("Memory encryption requested by %s", " and ".join(requesters))
